rdr <-
function(c.t, c.v, n=10, nt0 = n, nt1 = n, nv0=n, nv1=n, 
D=c(1), p0=0.9, p1=rep(c(1-p0)/length(D),length(D)), ng=10000 ){


	K<-length(D)
    if (K!=length(p1)){print("No!! the lengths of p1 and D should be same!"); break}
    
    w<-p1/sum(p1)
    p1<-p1/sum(p1)*(1-p0) # normailized			
    
    
    df.t<-nt0+nt1-2
    df.v<-nv0+nv1-2
    
    m.t<-sqrt(nt0*nt1/(nt0+nt1))
    m.v<-sqrt(nv0*nv1/(nv0+nv1))
    
    ncp.t<-m.t*D
    ncp.v<-m.v*D
    
    alpha.t <-2*(1-pt(c.t,df=df.t ))
	alpha.v<-2*(1-pt(c.v,df=df.v ))
			
			sens.tk<-sens.vk<-rep(0, K)

			for (i in 1:K){
				
				sens.tk[i]<-(1-
													pt(c.t, df=df.t, ncp=abs(ncp.t[i]))+
													pt(-c.t, df=df.t, ncp=abs(ncp.t[i])))

													
				sens.vk[i]<-(1-
													pt(c.v, df=df.v, ncp=abs(ncp.v[i]))+
													pt(-c.v, df=df.v, ncp=abs(ncp.v[i])))										
													
			}
			
			sens.t<-sum(w*sens.tk)
			
			
			sens.v<- sum(w*sens.vk)
				
			Vt<-ng*p0*alpha.t
			Rt<-ng*(p0*alpha.t	+(1-p0)*sens.t)


			Vv<-ng*(p0*alpha.t*alpha.v)
			Rv<-ng*(p0*alpha.t*alpha.v + (1-p0)*sum(w*sens.tk*sens.vk))
						
			#Theoretical RDR 
					
			RDR<-Rv/Rt
			FDR<-Vt/Rt
			vFDR<-Vv/Rv
							
				return(list(RDR=RDR, alpha.t=alpha.t,alpha.v=alpha.v, sens.t=sens.t,sens.v=sens.v,FDR=FDR,vFDR=vFDR,Vt=Vt,Vv=Vv,Rt=Rt,Rv=Rv))

	
}
