rdr.samplesize<-function (RDR = 0.8, c.t, c.v, nt0, nt1, cc.ratio = 1, 
    D = c(1), p0 = 0.9, p1 = rep(c(1 - p0)/length(D), length(D)), 
    plot.it = FALSE) 
{
    nv0 <- nt0
    nv1 <- ceiling(nv0 * cc.ratio)
    nv = nv0 + nv1
    maxrdr <- 0.99
    RDRs <- NULL
    conv <- 999
    while (conv > 0 & nv0 < 5000) {
    	ct<-	qt(10^(-c.t)/2,df=nt0+nt1-2,lower.tail=FALSE)		
       cv<-	qt(10^(-c.v)/2,df=nv0+nv1-2,lower.tail=FALSE)	
        RDR.est <- rdr(c.t=ct, c.v=cv, nt0 = nt0, nt1 = nt1, nv0 = nv0, 
            nv1 = nv1, D = D, p0 = p0, p1 = p1)$RDR
        conv <- maxrdr - RDR.est
        nv0 <- nv0 * 2
        nv1 <- ceiling(nv0 * cc.ratio)
        nv = nv0 + nv1
    }

    nv0<-max(5, nv0)
    nv0.set <- seq(5, nv0, ceiling(nv0/100))
    nn <- length(nv0.set)
    RDRs <- vFDRs<-oRDRs<-rep(0, nn)
    nv.set <- rep(0, nn)
    for (i in 1:nn) {
        nv0 <- nv0.set[i]
        nv1 <- ceiling(nv0 * cc.ratio)
        nv = nv0 + nv1
        nv.set[i] <- nv
        ct<-	qt(10^(-c.t)/2,df=nt0+nt1-2,lower.tail=FALSE)		
       cv<-	qt(10^(-c.v)/2,df=nv0+nv1-2,lower.tail=FALSE)	
        rdr.temp<-rdr(c.t=ct, c.v=cv, nt0 = nt0, nt1 = nt1, nv0 = nv0, 
            nv1 = nv1, D = D, p0 = p0, p1 = p1)
        RDRs[i] <- rdr.temp$RDR
        vFDRs[i] <- rdr.temp$vFDR
        if (RDRs[i] < RDR) {
            idx <- i
        }
    }
   
    nv0 <- nv0.set[idx]
    if (idx==nn){interval<-nv0.set[idx]}
    if (idx<nn){interval<-c(nv0.set[idx]:nv0.set[(idx + 1)])}
    for (nv0 in interval) {
        nv1 <- ceiling(nv0 * cc.ratio)
        nv = nv0 + nv1
       ct<-	qt(10^(-c.t)/2,df=nt0+nt1-2,lower.tail=FALSE)		
       cv<-	qt(10^(-c.v)/2,df=nv0+nv1-2,lower.tail=FALSE)	
        RDRest <- rdr(c.t=ct, c.v=cv, nt0 = nt0, nt1 = nt1, nv0 = nv0, 
            nv1 = nv1, D = D, p0 = p0, p1 = p1)$RDR
        if (RDRest > RDR) {
        		    nv0<-nv0-1
        	        nv1 <- ceiling(nv0 * cc.ratio)
        			nv = nv0 + nv1
            		break
        }
    }
    rst<-rdr(c.t=ct, c.v=cv, nt0 = nt0, nt1 = nt1, nv0 = nv0, 
            nv1 = nv1, D = D, p0 = p0, p1 = p1)
  
    rst$nv0<-nv0; rst$nv1<-nv1
    
    flag<-paste("For RDR = ",RDR, ", Proper sample sizes for validation=",nv0, ", ", nv1)
    if(max(RDRs) < RDR){flag<-"Even though the sample size > 10000, the RDR cannot reach to the target!"}
    
    if (plot.it == TRUE) {
        plot(RDRs[nv.set<2*nv] ~ nv.set[nv.set<2*nv], type = "l", main = "RDR curve", xlab = "Sample size in validation study", 
            ylab = "RDR")
        abline(h = RDRest, col = "grey")
        abline(v = nv, col = "grey")
    }
    rst$RDRs<-RDRs;rst$vFDRs<-vFDRs; rst$nv.set<-nv.set; rst$flag<-flag
    return(rst)
}